include \masm32\MasmBasic\MasmBasic.inc

; Demo showing how to use assembler from MS Word Visual Basic
; Use at your own risk
; If the dll is loaded in MS Word, you will get "fatal error: Access is denied"; if you
; see this error, click the Reset button in the Visual Basic editor to unlock the dll.

.data?
LineCount	dd ?
OldEbp	dd ?

.code
LibMain proc instance:DWORD, reason:DWORD, unused:DWORD
	m2m eax, TRUE
	ret
LibMain endp

GetString proc uses esi edi ebx MyIndex:DWORD, pString:DWORD	; $export
LOCAL abc, def, rc:RECT
  mov OldEbp, ebp	; works only with procs that have a stack frame
  mov esi, pString
  cmp MyIndex, -127	; trigger an error by passing a negative index
  je VbError
  .if LineCount==0
	mov edi, MbExeFolder$			; one of MasmBasic's predefined buffers
	invoke GetModuleHandle, Chr$("MbDll")		; GMFN 0 would yield path of calling exe
	invoke GetModuleFileName, eax, edi, MAX_PATH
	push [edi]			; save the first four characters
	mov edi, Chr$("?:\Masm32\include\Windows.inc")	; drive still unknown
	pop edx
	mov [edi], dl			; use the first char to set the drive
	.if Exist(edi)
		Recall edi, L$()			; load 22200 strings into the L$() array
		mov LineCount, eax
	.else
		jmp VbError			; file not found
	.endif
  .endif
  mov eax, MyIndex
  invoke MbCopy, esi, L$(eax), -1
  xchg eax, esi	; return pointer to pString
  xor eax, eax
  m2m eax, TRUE
  ret 
GetString endp

VbError:
	MsgBox 0, "Playing around?", "This is the DLL:", MB_OK
	mov esp, OldEbp	; ebp was esp-4
	pop edi	; aka add esp, 4
	retn

end LibMain
